Index: /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90
===================================================================
--- /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 8740)
+++ /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 8741)
@@ -109,11 +109,10 @@
       ! 
       ssha(:,:) = (  sshb(:,:) - z2dt * ( zcoef * ( emp_b(:,:) + emp(:,:) ) + zhdiv(:,:) )  ) * ssmask(:,:)
-
+      !
+#if defined key_agrif
+      CALL agrif_ssh( kt )
+#endif
+      !
       IF ( .NOT.ln_dynspg_ts ) THEN
-         ! These lines are not necessary with time splitting since
-         ! boundary condition on sea level is set during ts loop
-# if defined key_agrif
-         CALL agrif_ssh( kt )
-# endif
          IF( ln_bdy ) THEN
             CALL lbc_lnk( ssha, 'T', 1. )    ! Not sure that's necessary
@@ -214,4 +213,13 @@
          END DO
       ENDIF
+      !
+#if defined key_agrif 
+      IF( .NOT. AGRIF_Root() ) THEN 
+         IF ((nbondi ==  1).OR.(nbondi == 2)) wn(nlci-1 , :     ,:) = 0.e0      ! east 
+         IF ((nbondi == -1).OR.(nbondi == 2)) wn(2      , :     ,:) = 0.e0      ! west 
+         IF ((nbondj ==  1).OR.(nbondj == 2)) wn(:      ,nlcj-1 ,:) = 0.e0      ! north 
+         IF ((nbondj == -1).OR.(nbondj == 2)) wn(:      ,2      ,:) = 0.e0      ! south 
+      ENDIF 
+#endif 
       !
       IF( nn_timing == 1 )  CALL timing_stop('wzv')
Index: /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfgls.F90
===================================================================
--- /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfgls.F90	(revision 8740)
+++ /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfgls.F90	(revision 8741)
@@ -33,5 +33,8 @@
    USE iom            ! I/O manager library
    USE timing         ! Timing
-   USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
+   USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined) 
+#if defined key_agrif
+   USE agrif_opa_interp ! Set bc on avm
+#endif 
 
    IMPLICIT NONE
@@ -204,10 +207,12 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               avmu(ji,jj,jk) = avmu(ji,jj,jk) * ( un(ji,jj,jk-1) - un(ji,jj,jk) )   &
-                  &                            * ( ub(ji,jj,jk-1) - ub(ji,jj,jk) )   &
-                  &                            / (  e3uw_n(ji,jj,jk) * e3uw_b(ji,jj,jk) )
-               avmv(ji,jj,jk) = avmv(ji,jj,jk) * ( vn(ji,jj,jk-1) - vn(ji,jj,jk) )   &
-                  &                            * ( vb(ji,jj,jk-1) - vb(ji,jj,jk) )   &
-                  &                            / (  e3vw_n(ji,jj,jk) * e3vw_b(ji,jj,jk) )
+               avmu(ji,jj,jk) = 0.5_wp * ( avm(ji,jj,jk) + avm(ji+1,jj,jk) )   &
+                  &                    * ( un(ji,jj,jk-1) - un(ji,jj,jk)   )   &
+                  &                    * ( ub(ji,jj,jk-1) - ub(ji,jj,jk)   )   &
+                  &                    / (  e3uw_n(ji,jj,jk) * e3uw_b(ji,jj,jk) )
+               avmv(ji,jj,jk) = 0.5_wp * ( avm(ji,jj,jk) + avm(ji,jj+1,jk) )   & 
+                  &                    * ( vn(ji,jj,jk-1) - vn(ji,jj,jk)   )   &
+                  &                    * ( vb(ji,jj,jk-1) - vb(ji,jj,jk) )     &
+                  &                    / (  e3vw_n(ji,jj,jk) * e3vw_b(ji,jj,jk) )
                eps(ji,jj,jk)  = rc03 * en(ji,jj,jk) * SQRT(en(ji,jj,jk)) / mxln(ji,jj,jk)
             END DO
@@ -800,4 +805,9 @@
       ! Lateral boundary conditions (sign unchanged)
       avt(:,:,1)  = 0._wp
+      !
+#if defined key_agrif 
+      CALL Agrif_avm 
+#endif
+      !
       CALL lbc_lnk( avm, 'W', 1. )   ;   CALL lbc_lnk( avt, 'W', 1. )
 
Index: /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90
===================================================================
--- /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 8740)
+++ /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 8741)
@@ -173,9 +173,4 @@
       !!----------------------------------------------------------------------
       !
-#if defined key_agrif 
-      ! interpolation parent grid => child grid for avm_k ( ex : at west border: update column 1 and 2)
-      IF( .NOT.Agrif_Root() )   CALL Agrif_Tke
-#endif
-      !
       IF( kt /= nit000 ) THEN   ! restore before value to compute tke
          avt (:,:,:) = avt_k (:,:,:) 
@@ -196,5 +191,6 @@
 #if defined key_agrif
       ! Update child grid f => parent grid 
-      IF( .NOT.Agrif_Root() )   CALL Agrif_Update_Tke( kt )      ! children only
+!!! JC: suppress update since restartability is not possible in that case
+!!!      IF( .NOT.Agrif_Root() )   CALL Agrif_Update_Tke( )      ! children only
 #endif      
      ! 
@@ -666,4 +662,9 @@
          END DO
       END DO
+      !
+#if defined key_agrif 
+      CALL Agrif_avm 
+#endif
+      !
       CALL lbc_lnk( avm, 'W', 1. )      ! Lateral boundary conditions (sign unchanged)
       !
Index: /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/step.F90
===================================================================
--- /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 8740)
+++ /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 8741)
@@ -315,6 +315,10 @@
       IF( Agrif_NbStepint() == 0 ) THEN               ! AGRIF Update 
 !!jc in fact update is useless at last time step, but do it for global diagnostics
-                         CALL Agrif_Update_Tra()      ! Update active tracers
-                         CALL Agrif_Update_Dyn()      ! Update momentum
+         IF(.NOT.ln_linssh)  CALL Agrif_Update_vvl()      ! Update vertical scale factors  
+                             CALL Agrif_Update_Tra()      ! Update active tracers
+                             CALL Agrif_Update_Dyn()      ! Update momentum
+#if defined key_top
+                             CALL Agrif_Update_Trc()      ! Update passive tracers
+#endif
       ENDIF
 #endif
Index: /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/step_oce.F90
===================================================================
--- /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/step_oce.F90	(revision 8740)
+++ /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/OPA_SRC/step_oce.F90	(revision 8741)
@@ -113,4 +113,7 @@
    USE agrif_opa_sponge ! Momemtum and tracers sponges
    USE agrif_opa_update ! Update (2-way nesting)
+#if defined key_top
+   USE agrif_top_update ! passive tracers update (2-way nesting)
+#endif
 #endif
 #if defined key_top
Index: /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90
===================================================================
--- /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 8740)
+++ /branches/2017/dev_r8624_AGRIF3_VVL/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 8741)
@@ -30,5 +30,4 @@
 #if defined key_agrif
    USE agrif_top_sponge ! tracers sponges
-   USE agrif_top_update ! tracers updates
 #endif
 
@@ -83,7 +82,4 @@
          IF( ln_trcdmp_clo )    CALL trc_dmp_clo( kt )      ! internal damping trends on closed seas only
 
-#if defined key_agrif
-         IF( .NOT.Agrif_Root()) CALL Agrif_Update_Trc( kt ) ! Update tracer at AGRIF zoom boundaries : children only
-#endif
          !
       ELSE                                               ! 1D vertical configuration
